#!/usr/bin/python
# -*- coding: utf-8 -*-
# name pg.py: Berechnung der Nullstellen eines quadratischen Polynoms
# Authorv: M. Ries

import numpy as np

eps = 1.0e-12
p = float( input('Bitte p eingeben:> ') )
p_halbe = p/2.0e0                 # Achtung: p u.U. vom Type 'Ganze Zahl'
# print( ' p_halbe = ', p_halbe )
q = float( input('      und nun q :> ') )
radikand = p_halbe**2 - q
# print('radikand = ', radikand)

if radikand > 0:
	x_1 = -p_halbe + np.sqrt( radikand )  # vorne sind 2 'tab'-Zeichen
	x_2 = -p_halbe - np.sqrt( radikand ) 
	print('Die beiden reellen Nullstellen lauten {0:20.13f}\n'
	      '                                  und {1:20.13f}'
	      .format( x_1, x_2 ) )
	# und nun die Probe
	q_probe =    x_1 * x_2         # Probe nach satz von Vieta
	p_probe = - (x_1 + x_2)
	if (q - q_probe)**2 + ( p - p_probe ) > eps:
		print( 'Das ergebnis ist wahrscheinlich falsch' )
	else:
		print( 'Probe: o.k.' )
	# ende if else
elif radikand < 0:   
	x_1 = complex(-p_halbe,  + np.sqrt( -radikand ) ) 
	x_2 = complex(-p_halbe,  - np.sqrt( -radikand ) )
	print('Die beiden komplexen Nullstellen lauten '
	      '{0:11.7f} + {1:11.7f} i\n'
	      '                                    und '
	      '{2:11.7f} + {3:11.7f} i'
	      .format( x_1.real, x_1.imag, x_2.real, x_2.imag) )
	q_probe =    x_1 * x_2
	p_probe = - (x_1 + x_2)
	# Hier fehlt noch die Ausgabe der Probe
else:   # nun bleib nur noch radikand == 0
	x = -p_halbe
    # Probe !!
	print('Es gibt nur eine Lösung: x = {0:11.7f}'.format( x ) )    
	
# ende if elif else
    

